.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\comdlg32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\comdlg32.lib
includelib  \masm32\lib\masm32.lib
; ************************************

; Prototype 
; ************************************
DialogProc   PROTO : HWND, : UINT, : WPARAM, : LPARAM
WndEnumProc  PROTO :HWND,:LPARAM
.const

; Resource ids
; ************************************
IDD_DLG1  	  equ 101
IDC_BTN1      equ 102
IDI_ICON      equ 200
MAXSIZE       equ 260
; Required data
; ************************************
.data
szTitle       db "GetClassName & WindowName Tool", 0
Error         db "Error!",0
NoMem         db "Error allocating memory",0
NoFile        db "Can't find the file!",0
FilterString  db "All Files",0,"*.*",0
              db "Executable Files",0,"*.exe",0,0
FilePath      db 260 dup (0)

Caption       db "Choose the file:",0
FSize         dd 0
ofn OPENFILENAME <>

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hFile     HANDLE ?
Numb     dd ?
FPointer dd ?
.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ************************************
;   Call the dialog box stored in resource file
; ************************************
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM


 .IF uMsg == WM_INITDIALOG
 
INVOKE SetWindowText, hWnd, addr szTitle 
INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
.ELSEIF uMsg == WM_COMMAND
.IF wParam == 102
mov ofn.lStructSize,SIZEOF ofn
mov ofn.lpstrFile, OFFSET FilePath
mov ofn.lpstrFilter, OFFSET FilterString
mov ofn.nMaxFile,MAXSIZE
mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
mov ofn.lpstrTitle, OFFSET Caption

INVOKE GetOpenFileName, addr ofn
 .IF eax == TRUE
; Open the file
invoke CreateFile, ofn.lpstrFile, GENERIC_READ OR GENERIC_WRITE, FILE_SHARE_READ OR FILE_SHARE_WRITE, NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL

.IF eax!=INVALID_HANDLE_VALUE
mov [hFile], eax ; Store handle of file
Invoke GetFileSize, hFile, NULL
mov FSize, eax ; Save FileSize
Invoke GlobalAlloc, GMEM_FIXED, FSize
mov FPointer, eax

.IF eax == NULL ; If no pointer, error message
invoke MessageBox, hWnd, addr NoMem, addr Error, MB_ICONINFORMATION

.ENDIF

Invoke ReadFile, hFile,FPointer,FSize, addr Numb, NULL

.ELSE ;If no valid handle, error message
invoke MessageBox, hWnd, addr NoFile, addr Error, MB_ICONINFORMATION

.ENDIF
.ENDIF
.ENDIF


INVOKE  EnumWindows,WndEnumProc,hFile

.ELSEIF uMsg == WM_CLOSE ; Close program
INVOKE CloseHandle, hFile ; Release handle
INVOKE GlobalFree, FPointer ; Release memory block
INVOKE EndDialog, hWnd, 0 ; Exit
.ENDIF

    xor eax,eax
  ret
DialogProc endp
; EnumChildProc procedure
; ************************************
WndEnumProc PROC hwnd:HWND,lParam:LPARAM

LOCAL   lpClassName [256]:BYTE 
LOCAL   lpWindowName[256]:BYTE 

INVOKE  GetClassName,hwnd,addr lpClassName,sizeof lpClassName
INVOKE	GetWindowText, hwnd, addr  lpWindowName ,sizeof lpWindowName
INVOKE  MessageBox,NULL,addr lpClassName,addr lpWindowName ,MB_OK

    xor eax,eax
  ret

WndEnumProc ENDP
end start