.486
.model flat, stdcall
option casemap: none

; API functions
; ************************************
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\comdlg32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\shell32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\comdlg32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\shell32.lib
; ************************************

; Prototype 
; ************************************
DialogProc      PROTO : HWND, : UINT, : WPARAM, : LPARAM
EnumWindowsProc PROTO :DWORD,:LPARAM
.const

; Resource ids
; ************************************
IDD_DLG1  	equ 101
IDC_BTN1    equ 102
IDC_FILE	equ 103
IDC_CLASS	equ 104
IDC_WNAME	equ 105
IDI_ICON    equ 200
Max_Buffer  equ 256 ; set to at least maximum length of name 

; Required data
; ************************************
.data
ofn	   OPENFILENAME <>
cFname   db MAX_PATH dup (0)
szTitle       db "Get ClassName & WindowName Tool", 0
filterstring  db "exe files",0,"*.exe",0,"all files",0,"*.*",0,0
szCurDir      db "*.*",0
szNoFile      db "No File Selected!",0
szErr         db "Error!",0
format    db "%X",0 ; wsprintfA format
lpClassName		  dd Max_Buffer dup (00)			;buffer for lpClassName
lpWindowName       dd Max_Buffer dup (00)			;buffer for lpWindowName
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?

buffer	db 512 dup (?)
tempbuffer	db 512 dup (?)
Numb     dd ?
FPointer dd ?
FSize    dd ?
hFile    HANDLE ?

.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ************************************
;   Call the dialog box stored in resource file
; ************************************
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM
	LOCAL  hDrop : HANDLE

 .IF uMsg == WM_INITDIALOG
 
INVOKE SetWindowText, hWnd, addr szTitle 
INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
INVOKE DragAcceptFiles,hWnd,TRUE

 .ELSEIF uMsg == WM_DROPFILES
push wParam
pop hDrop
INVOKE DragQueryFile,hDrop,0,offset cFname,sizeof cFname
INVOKE DragFinish,hDrop
INVOKE SetDlgItemText,hWnd,IDC_FILE,offset cFname 
 
.ELSEIF uMsg == WM_COMMAND
mov eax,wParam
mov edx,wParam
shr edx,16
.IF dx==BN_CLICKED
.IF ax == 102
; get a file path
	mov [ofn.lStructSize],sizeof ofn
	mov [ofn.lpstrFilter],OFFSET filterstring
	push hWnd
	pop ofn.hwndOwner
	mov [ofn.lpstrFile],offset cFname 
	mov [ofn.nMaxFile],SIZEOF cFname
	mov ofn.lpstrInitialDir,offset szCurDir
	mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_HIDEREADONLY
	push offset ofn
	call GetOpenFileName
	test eax,eax
	.IF eax!=1
	jz @@Error

	@@Error:
Invoke MessageBox,hWnd, addr szNoFile, addr szErr , MB_ICONERROR
	.ELSEIF
; Open the file
	invoke SetDlgItemText,hWnd,IDC_FILE,offset cFname

	invoke CreateFile,buffer,GENERIC_READ,0,0,OPEN_EXISTING,20h,0
	
.IF eax!=INVALID_HANDLE_VALUE
mov hFile, eax ; Store handle of file
Invoke ReadFile, hFile,FPointer,FSize, addr Numb, NULL

.ENDIF
.ENDIF
.ENDIF
.ENDIF
; ************************************
INVOKE EnumWindows,EnumWindowsProc, hFile
; ************************************

.ELSEIF uMsg == WM_CLOSE ; Close program
invoke CloseHandle,hFile
INVOKE EndDialog, hWnd, 0 ; Exit
.ENDIF

xor eax,eax
ret
DialogProc endp
; EnumWindowsProc procedure
; ************************************
EnumWindowsProc PROC hWnd:DWORD,lParam:LPARAM



INVOKE  GetClassName,hWnd,offset lpClassName,sizeof lpClassName
INVOKE wsprintf,addr tempbuffer, addr format,NULL
INVOKE lstrcat ,addr tempbuffer, addr lpClassName ; copy name to  buffer
INVOKE SetDlgItemText,hWnd,IDC_CLASS,addr tempbuffer ; display



INVOKE	GetWindowText,hWnd, offset lpWindowName ,sizeof lpWindowName
;INVOKE wsprintf,addr tempbuffer, addr format,NULL
;INVOKE lstrcat, addr lpWindowName, addr tempbuffer ; copy name to  buffer
INVOKE SetDlgItemText,hWnd,IDC_WNAME, addr lpWindowName; display


;INVOKE  MessageBox,NULL,addr lpClassName,addr lpWindowName ,MB_OK



xor eax,eax
ret

EnumWindowsProc ENDP
end start